//import java.lang.*;
import java.util.*;
import java.io.*;


/** Klasse zur Verwaltung der Artikel
  * @author Bernhard Fiser 0109815 */
public class ArtikelVerwaltung implements Serializable
{
	private HashMap	hmap;

	/** Constructor
	  * legt eine neue Hashmap an, in der die Artikelobjekte
	  * gespeichert werden */
	public ArtikelVerwaltung()
	{
		this.hmap = new HashMap();
	}

	/** ndert einen Artikel, sofern vorhanden,
	  * andernfalls wird der Artikel neu zur Hashmap
	  * hinzugefgt */
	public boolean changeArtikel(Artikel a)
	{
		hmap.remove(a.getID());
		hmap.put(a.getID(), a);
		return(true);
	}

	/** lscht einen Artikel von der Hashmap */
	public boolean deleteArtikel(Artikel a)
	{
		/* Falls bergebener Parameter null ist, false zurckgeben */
		if (a == null)
			return(false);
		/* Falls sich Artikel nicht lschen lsst (weil er gar nicht
		 * existiert), dann false zurckgeben */
		if (hmap.remove(a.getID()) == null)
			return(false);
		/* Andernfalls Lschung erfolgreich -> true zurckgeben */
		return(true);
	}

	/** Artikel anhand der Artikelnummer suchen und zurckliefern
	  * @param int id : Artikelnummer des gesuchten Artikels */
	public Artikel getArtikel(int id)
	{
		/* id in Integerobject umwandeln */
		Integer i = new Integer(id);
		/* Artikelobjekt suchen und zurckgeben */
		return((Artikel) hmap.get(i));
	}

	/** Iterator fr die interne Hashmap erstellen
	  * @return Iterator */
	public Iterator iterator()
	{
		return(hmap.values().iterator());
	}
}
